/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.core.engine.observations;

import tools.descartes.dql.connector.PerformanceMetricsQueryConnector;
import tools.descartes.dql.lang.descartesQL.ConnectorTimeUnitClause;

public class ConnectorTimeUnitInterpreter implements ObservationInterpreter {
	private final ConnectorTimeUnitClause observation;

	public ConnectorTimeUnitInterpreter(final ConnectorTimeUnitClause observation) {
		this.observation = observation;
	}

	@Override
	public void configureConnector(final PerformanceMetricsQueryConnector queryConnector, final long sampleSize) {
		final int amount = observation.getCount();
		final String unit = observation.getTimeIndicator();

		queryConnector.setObservationPeriod(amount, unit, sampleSize);
	}

	@Override
	public void interpretDate() {
		// Nothing to do here
		return;
	}

}
