/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Generate SLA Concern</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getOffset <em>Offset</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getPercentage <em>Percentage</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getConstraintClause <em>Constraint Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getDofClause <em>Dof Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getUsingClause <em>Using Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern()
 * @model
 * @generated
 */
public interface GenerateSLAConcern extends EObject
{
  /**
   * Returns the value of the '<em><b>Offset</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Offset</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Offset</em>' containment reference.
   * @see #setOffset(MultipleArithmeticClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_Offset()
   * @model containment="true"
   * @generated
   */
  MultipleArithmeticClause getOffset();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getOffset <em>Offset</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Offset</em>' containment reference.
   * @see #getOffset()
   * @generated
   */
  void setOffset(MultipleArithmeticClause value);

  /**
   * Returns the value of the '<em><b>Percentage</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Percentage</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Percentage</em>' attribute.
   * @see #setPercentage(double)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_Percentage()
   * @model
   * @generated
   */
  double getPercentage();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getPercentage <em>Percentage</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Percentage</em>' attribute.
   * @see #getPercentage()
   * @generated
   */
  void setPercentage(double value);

  /**
   * Returns the value of the '<em><b>Constraint Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Constraint Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Constraint Clause</em>' containment reference.
   * @see #setConstraintClause(ConstraintClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_ConstraintClause()
   * @model containment="true"
   * @generated
   */
  ConstraintClause getConstraintClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getConstraintClause <em>Constraint Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Constraint Clause</em>' containment reference.
   * @see #getConstraintClause()
   * @generated
   */
  void setConstraintClause(ConstraintClause value);

  /**
   * Returns the value of the '<em><b>Dof Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Dof Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Dof Clause</em>' containment reference.
   * @see #setDofClause(DoFClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_DofClause()
   * @model containment="true"
   * @generated
   */
  DoFClause getDofClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getDofClause <em>Dof Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Dof Clause</em>' containment reference.
   * @see #getDofClause()
   * @generated
   */
  void setDofClause(DoFClause value);

  /**
   * Returns the value of the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Clause</em>' containment reference.
   * @see #setForClause(ForClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_ForClause()
   * @model containment="true"
   * @generated
   */
  ForClause getForClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getForClause <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Clause</em>' containment reference.
   * @see #getForClause()
   * @generated
   */
  void setForClause(ForClause value);

  /**
   * Returns the value of the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Using Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Using Clause</em>' containment reference.
   * @see #setUsingClause(UsingClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGenerateSLAConcern_UsingClause()
   * @model containment="true"
   * @generated
   */
  UsingClause getUsingClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.GenerateSLAConcern#getUsingClause <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Using Clause</em>' containment reference.
   * @see #getUsingClause()
   * @generated
   */
  void setUsingClause(UsingClause value);

} // GenerateSLAConcern
