/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Penalty</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Penalty#getType <em>Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Penalty#getValue <em>Value</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Penalty#getCurrency <em>Currency</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getPenalty()
 * @model
 * @generated
 */
public interface Penalty extends EObject
{
  /**
   * Returns the value of the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' attribute.
   * @see #setType(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getPenalty_Type()
   * @model
   * @generated
   */
  String getType();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Penalty#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' attribute.
   * @see #getType()
   * @generated
   */
  void setType(String value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' attribute.
   * @see #setValue(double)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getPenalty_Value()
   * @model
   * @generated
   */
  double getValue();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Penalty#getValue <em>Value</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' attribute.
   * @see #getValue()
   * @generated
   */
  void setValue(double value);

  /**
   * Returns the value of the '<em><b>Currency</b></em>' attribute.
   * The literals are from the enumeration {@link tools.descartes.dql.lang.descartesQL.Currency}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Currency</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Currency</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.Currency
   * @see #setCurrency(Currency)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getPenalty_Currency()
   * @model
   * @generated
   */
  Currency getCurrency();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Penalty#getCurrency <em>Currency</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Currency</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.Currency
   * @see #getCurrency()
   * @generated
   */
  void setCurrency(Currency value);

} // Penalty
