/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Slo</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getMetricClauseType <em>Metric Clause Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getComparator <em>Comparator</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getValue <em>Value</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getFuz <em>Fuz</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getPen <em>Pen</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Slo#getViolation <em>Violation</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo()
 * @model
 * @generated
 */
public interface Slo extends EObject
{
  /**
   * Returns the value of the '<em><b>Name</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Name</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Name</em>' attribute.
   * @see #setName(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Name()
   * @model
   * @generated
   */
  String getName();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getName <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Name</em>' attribute.
   * @see #getName()
   * @generated
   */
  void setName(String value);

  /**
   * Returns the value of the '<em><b>Metric Clause Type</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metric Clause Type</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metric Clause Type</em>' containment reference.
   * @see #setMetricClauseType(MetricClauseType)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_MetricClauseType()
   * @model containment="true"
   * @generated
   */
  MetricClauseType getMetricClauseType();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getMetricClauseType <em>Metric Clause Type</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metric Clause Type</em>' containment reference.
   * @see #getMetricClauseType()
   * @generated
   */
  void setMetricClauseType(MetricClauseType value);

  /**
   * Returns the value of the '<em><b>Comparator</b></em>' attribute.
   * The literals are from the enumeration {@link tools.descartes.dql.lang.descartesQL.Comparator}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Comparator</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Comparator</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.Comparator
   * @see #setComparator(Comparator)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Comparator()
   * @model
   * @generated
   */
  Comparator getComparator();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getComparator <em>Comparator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Comparator</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.Comparator
   * @see #getComparator()
   * @generated
   */
  void setComparator(Comparator value);

  /**
   * Returns the value of the '<em><b>Value</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Value</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Value</em>' containment reference.
   * @see #setValue(VariableValue)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Value()
   * @model containment="true"
   * @generated
   */
  VariableValue getValue();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getValue <em>Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Value</em>' containment reference.
   * @see #getValue()
   * @generated
   */
  void setValue(VariableValue value);

  /**
   * Returns the value of the '<em><b>Fuz</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Fuz</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Fuz</em>' containment reference.
   * @see #setFuz(Fuzziness)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Fuz()
   * @model containment="true"
   * @generated
   */
  Fuzziness getFuz();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getFuz <em>Fuz</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Fuz</em>' containment reference.
   * @see #getFuz()
   * @generated
   */
  void setFuz(Fuzziness value);

  /**
   * Returns the value of the '<em><b>Pen</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Pen</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Pen</em>' containment reference.
   * @see #setPen(Penalty)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Pen()
   * @model containment="true"
   * @generated
   */
  Penalty getPen();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getPen <em>Pen</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Pen</em>' containment reference.
   * @see #getPen()
   * @generated
   */
  void setPen(Penalty value);

  /**
   * Returns the value of the '<em><b>Violation</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Violation</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Violation</em>' containment reference.
   * @see #setViolation(Violation)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlo_Violation()
   * @model containment="true"
   * @generated
   */
  Violation getViolation();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Slo#getViolation <em>Violation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Violation</em>' containment reference.
   * @see #getViolation()
   * @generated
   */
  void setViolation(Violation value);

} // Slo
