/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.ConstraintClause;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.DoFClause;
import tools.descartes.dql.lang.descartesQL.ForClause;
import tools.descartes.dql.lang.descartesQL.Goal;
import tools.descartes.dql.lang.descartesQL.SlaQuery;
import tools.descartes.dql.lang.descartesQL.SloQuery;
import tools.descartes.dql.lang.descartesQL.UsingClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Goal</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getQueryType <em>Query Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getSlaQuery <em>Sla Query</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getSloQuery <em>Slo Query</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getConstraintClause <em>Constraint Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getDofClause <em>Dof Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.GoalImpl#getUsingClause <em>Using Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class GoalImpl extends MinimalEObjectImpl.Container implements Goal
{
  /**
   * The default value of the '{@link #getQueryType() <em>Query Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQueryType()
   * @generated
   * @ordered
   */
  protected static final String QUERY_TYPE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getQueryType() <em>Query Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getQueryType()
   * @generated
   * @ordered
   */
  protected String queryType = QUERY_TYPE_EDEFAULT;

  /**
   * The cached value of the '{@link #getSlaQuery() <em>Sla Query</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSlaQuery()
   * @generated
   * @ordered
   */
  protected SlaQuery slaQuery;

  /**
   * The cached value of the '{@link #getSloQuery() <em>Slo Query</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getSloQuery()
   * @generated
   * @ordered
   */
  protected SloQuery sloQuery;

  /**
   * The cached value of the '{@link #getConstraintClause() <em>Constraint Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getConstraintClause()
   * @generated
   * @ordered
   */
  protected ConstraintClause constraintClause;

  /**
   * The cached value of the '{@link #getDofClause() <em>Dof Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDofClause()
   * @generated
   * @ordered
   */
  protected DoFClause dofClause;

  /**
   * The cached value of the '{@link #getForClause() <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getForClause()
   * @generated
   * @ordered
   */
  protected ForClause forClause;

  /**
   * The cached value of the '{@link #getUsingClause() <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsingClause()
   * @generated
   * @ordered
   */
  protected UsingClause usingClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected GoalImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.GOAL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getQueryType()
  {
    return queryType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setQueryType(String newQueryType)
  {
    String oldQueryType = queryType;
    queryType = newQueryType;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__QUERY_TYPE, oldQueryType, queryType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SlaQuery getSlaQuery()
  {
    return slaQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSlaQuery(SlaQuery newSlaQuery, NotificationChain msgs)
  {
    SlaQuery oldSlaQuery = slaQuery;
    slaQuery = newSlaQuery;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__SLA_QUERY, oldSlaQuery, newSlaQuery);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSlaQuery(SlaQuery newSlaQuery)
  {
    if (newSlaQuery != slaQuery)
    {
      NotificationChain msgs = null;
      if (slaQuery != null)
        msgs = ((InternalEObject)slaQuery).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__SLA_QUERY, null, msgs);
      if (newSlaQuery != null)
        msgs = ((InternalEObject)newSlaQuery).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__SLA_QUERY, null, msgs);
      msgs = basicSetSlaQuery(newSlaQuery, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__SLA_QUERY, newSlaQuery, newSlaQuery));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SloQuery getSloQuery()
  {
    return sloQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetSloQuery(SloQuery newSloQuery, NotificationChain msgs)
  {
    SloQuery oldSloQuery = sloQuery;
    sloQuery = newSloQuery;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__SLO_QUERY, oldSloQuery, newSloQuery);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setSloQuery(SloQuery newSloQuery)
  {
    if (newSloQuery != sloQuery)
    {
      NotificationChain msgs = null;
      if (sloQuery != null)
        msgs = ((InternalEObject)sloQuery).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__SLO_QUERY, null, msgs);
      if (newSloQuery != null)
        msgs = ((InternalEObject)newSloQuery).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__SLO_QUERY, null, msgs);
      msgs = basicSetSloQuery(newSloQuery, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__SLO_QUERY, newSloQuery, newSloQuery));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConstraintClause getConstraintClause()
  {
    return constraintClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetConstraintClause(ConstraintClause newConstraintClause, NotificationChain msgs)
  {
    ConstraintClause oldConstraintClause = constraintClause;
    constraintClause = newConstraintClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE, oldConstraintClause, newConstraintClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setConstraintClause(ConstraintClause newConstraintClause)
  {
    if (newConstraintClause != constraintClause)
    {
      NotificationChain msgs = null;
      if (constraintClause != null)
        msgs = ((InternalEObject)constraintClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE, null, msgs);
      if (newConstraintClause != null)
        msgs = ((InternalEObject)newConstraintClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE, null, msgs);
      msgs = basicSetConstraintClause(newConstraintClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE, newConstraintClause, newConstraintClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoFClause getDofClause()
  {
    return dofClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetDofClause(DoFClause newDofClause, NotificationChain msgs)
  {
    DoFClause oldDofClause = dofClause;
    dofClause = newDofClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__DOF_CLAUSE, oldDofClause, newDofClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDofClause(DoFClause newDofClause)
  {
    if (newDofClause != dofClause)
    {
      NotificationChain msgs = null;
      if (dofClause != null)
        msgs = ((InternalEObject)dofClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__DOF_CLAUSE, null, msgs);
      if (newDofClause != null)
        msgs = ((InternalEObject)newDofClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__DOF_CLAUSE, null, msgs);
      msgs = basicSetDofClause(newDofClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__DOF_CLAUSE, newDofClause, newDofClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ForClause getForClause()
  {
    return forClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetForClause(ForClause newForClause, NotificationChain msgs)
  {
    ForClause oldForClause = forClause;
    forClause = newForClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__FOR_CLAUSE, oldForClause, newForClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setForClause(ForClause newForClause)
  {
    if (newForClause != forClause)
    {
      NotificationChain msgs = null;
      if (forClause != null)
        msgs = ((InternalEObject)forClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__FOR_CLAUSE, null, msgs);
      if (newForClause != null)
        msgs = ((InternalEObject)newForClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__FOR_CLAUSE, null, msgs);
      msgs = basicSetForClause(newForClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__FOR_CLAUSE, newForClause, newForClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UsingClause getUsingClause()
  {
    return usingClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetUsingClause(UsingClause newUsingClause, NotificationChain msgs)
  {
    UsingClause oldUsingClause = usingClause;
    usingClause = newUsingClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__USING_CLAUSE, oldUsingClause, newUsingClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUsingClause(UsingClause newUsingClause)
  {
    if (newUsingClause != usingClause)
    {
      NotificationChain msgs = null;
      if (usingClause != null)
        msgs = ((InternalEObject)usingClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__USING_CLAUSE, null, msgs);
      if (newUsingClause != null)
        msgs = ((InternalEObject)newUsingClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.GOAL__USING_CLAUSE, null, msgs);
      msgs = basicSetUsingClause(newUsingClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.GOAL__USING_CLAUSE, newUsingClause, newUsingClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.GOAL__SLA_QUERY:
        return basicSetSlaQuery(null, msgs);
      case DescartesQLPackage.GOAL__SLO_QUERY:
        return basicSetSloQuery(null, msgs);
      case DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE:
        return basicSetConstraintClause(null, msgs);
      case DescartesQLPackage.GOAL__DOF_CLAUSE:
        return basicSetDofClause(null, msgs);
      case DescartesQLPackage.GOAL__FOR_CLAUSE:
        return basicSetForClause(null, msgs);
      case DescartesQLPackage.GOAL__USING_CLAUSE:
        return basicSetUsingClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.GOAL__QUERY_TYPE:
        return getQueryType();
      case DescartesQLPackage.GOAL__SLA_QUERY:
        return getSlaQuery();
      case DescartesQLPackage.GOAL__SLO_QUERY:
        return getSloQuery();
      case DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE:
        return getConstraintClause();
      case DescartesQLPackage.GOAL__DOF_CLAUSE:
        return getDofClause();
      case DescartesQLPackage.GOAL__FOR_CLAUSE:
        return getForClause();
      case DescartesQLPackage.GOAL__USING_CLAUSE:
        return getUsingClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.GOAL__QUERY_TYPE:
        setQueryType((String)newValue);
        return;
      case DescartesQLPackage.GOAL__SLA_QUERY:
        setSlaQuery((SlaQuery)newValue);
        return;
      case DescartesQLPackage.GOAL__SLO_QUERY:
        setSloQuery((SloQuery)newValue);
        return;
      case DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE:
        setConstraintClause((ConstraintClause)newValue);
        return;
      case DescartesQLPackage.GOAL__DOF_CLAUSE:
        setDofClause((DoFClause)newValue);
        return;
      case DescartesQLPackage.GOAL__FOR_CLAUSE:
        setForClause((ForClause)newValue);
        return;
      case DescartesQLPackage.GOAL__USING_CLAUSE:
        setUsingClause((UsingClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.GOAL__QUERY_TYPE:
        setQueryType(QUERY_TYPE_EDEFAULT);
        return;
      case DescartesQLPackage.GOAL__SLA_QUERY:
        setSlaQuery((SlaQuery)null);
        return;
      case DescartesQLPackage.GOAL__SLO_QUERY:
        setSloQuery((SloQuery)null);
        return;
      case DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE:
        setConstraintClause((ConstraintClause)null);
        return;
      case DescartesQLPackage.GOAL__DOF_CLAUSE:
        setDofClause((DoFClause)null);
        return;
      case DescartesQLPackage.GOAL__FOR_CLAUSE:
        setForClause((ForClause)null);
        return;
      case DescartesQLPackage.GOAL__USING_CLAUSE:
        setUsingClause((UsingClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.GOAL__QUERY_TYPE:
        return QUERY_TYPE_EDEFAULT == null ? queryType != null : !QUERY_TYPE_EDEFAULT.equals(queryType);
      case DescartesQLPackage.GOAL__SLA_QUERY:
        return slaQuery != null;
      case DescartesQLPackage.GOAL__SLO_QUERY:
        return sloQuery != null;
      case DescartesQLPackage.GOAL__CONSTRAINT_CLAUSE:
        return constraintClause != null;
      case DescartesQLPackage.GOAL__DOF_CLAUSE:
        return dofClause != null;
      case DescartesQLPackage.GOAL__FOR_CLAUSE:
        return forClause != null;
      case DescartesQLPackage.GOAL__USING_CLAUSE:
        return usingClause != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (queryType: ");
    result.append(queryType);
    result.append(')');
    return result.toString();
  }

} //GoalImpl
