/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.Comparator;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.Fuzziness;
import tools.descartes.dql.lang.descartesQL.MetricClauseType;
import tools.descartes.dql.lang.descartesQL.Penalty;
import tools.descartes.dql.lang.descartesQL.Slo;
import tools.descartes.dql.lang.descartesQL.VariableValue;
import tools.descartes.dql.lang.descartesQL.Violation;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Slo</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getName <em>Name</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getMetricClauseType <em>Metric Clause Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getComparator <em>Comparator</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getValue <em>Value</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getFuz <em>Fuz</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getPen <em>Pen</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.SloImpl#getViolation <em>Violation</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SloImpl extends MinimalEObjectImpl.Container implements Slo
{
  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * The cached value of the '{@link #getMetricClauseType() <em>Metric Clause Type</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetricClauseType()
   * @generated
   * @ordered
   */
  protected MetricClauseType metricClauseType;

  /**
   * The default value of the '{@link #getComparator() <em>Comparator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComparator()
   * @generated
   * @ordered
   */
  protected static final Comparator COMPARATOR_EDEFAULT = Comparator.LESS;

  /**
   * The cached value of the '{@link #getComparator() <em>Comparator</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComparator()
   * @generated
   * @ordered
   */
  protected Comparator comparator = COMPARATOR_EDEFAULT;

  /**
   * The cached value of the '{@link #getValue() <em>Value</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValue()
   * @generated
   * @ordered
   */
  protected VariableValue value;

  /**
   * The cached value of the '{@link #getFuz() <em>Fuz</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFuz()
   * @generated
   * @ordered
   */
  protected Fuzziness fuz;

  /**
   * The cached value of the '{@link #getPen() <em>Pen</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPen()
   * @generated
   * @ordered
   */
  protected Penalty pen;

  /**
   * The cached value of the '{@link #getViolation() <em>Violation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getViolation()
   * @generated
   * @ordered
   */
  protected Violation violation;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SloImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.SLO;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__NAME, oldName, name));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricClauseType getMetricClauseType()
  {
    return metricClauseType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMetricClauseType(MetricClauseType newMetricClauseType, NotificationChain msgs)
  {
    MetricClauseType oldMetricClauseType = metricClauseType;
    metricClauseType = newMetricClauseType;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE, oldMetricClauseType, newMetricClauseType);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMetricClauseType(MetricClauseType newMetricClauseType)
  {
    if (newMetricClauseType != metricClauseType)
    {
      NotificationChain msgs = null;
      if (metricClauseType != null)
        msgs = ((InternalEObject)metricClauseType).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE, null, msgs);
      if (newMetricClauseType != null)
        msgs = ((InternalEObject)newMetricClauseType).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE, null, msgs);
      msgs = basicSetMetricClauseType(newMetricClauseType, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE, newMetricClauseType, newMetricClauseType));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Comparator getComparator()
  {
    return comparator;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setComparator(Comparator newComparator)
  {
    Comparator oldComparator = comparator;
    comparator = newComparator == null ? COMPARATOR_EDEFAULT : newComparator;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__COMPARATOR, oldComparator, comparator));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariableValue getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetValue(VariableValue newValue, NotificationChain msgs)
  {
    VariableValue oldValue = value;
    value = newValue;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__VALUE, oldValue, newValue);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setValue(VariableValue newValue)
  {
    if (newValue != value)
    {
      NotificationChain msgs = null;
      if (value != null)
        msgs = ((InternalEObject)value).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__VALUE, null, msgs);
      if (newValue != null)
        msgs = ((InternalEObject)newValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__VALUE, null, msgs);
      msgs = basicSetValue(newValue, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__VALUE, newValue, newValue));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fuzziness getFuz()
  {
    return fuz;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFuz(Fuzziness newFuz, NotificationChain msgs)
  {
    Fuzziness oldFuz = fuz;
    fuz = newFuz;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__FUZ, oldFuz, newFuz);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFuz(Fuzziness newFuz)
  {
    if (newFuz != fuz)
    {
      NotificationChain msgs = null;
      if (fuz != null)
        msgs = ((InternalEObject)fuz).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__FUZ, null, msgs);
      if (newFuz != null)
        msgs = ((InternalEObject)newFuz).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__FUZ, null, msgs);
      msgs = basicSetFuz(newFuz, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__FUZ, newFuz, newFuz));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Penalty getPen()
  {
    return pen;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetPen(Penalty newPen, NotificationChain msgs)
  {
    Penalty oldPen = pen;
    pen = newPen;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__PEN, oldPen, newPen);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPen(Penalty newPen)
  {
    if (newPen != pen)
    {
      NotificationChain msgs = null;
      if (pen != null)
        msgs = ((InternalEObject)pen).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__PEN, null, msgs);
      if (newPen != null)
        msgs = ((InternalEObject)newPen).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__PEN, null, msgs);
      msgs = basicSetPen(newPen, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__PEN, newPen, newPen));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Violation getViolation()
  {
    return violation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetViolation(Violation newViolation, NotificationChain msgs)
  {
    Violation oldViolation = violation;
    violation = newViolation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__VIOLATION, oldViolation, newViolation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setViolation(Violation newViolation)
  {
    if (newViolation != violation)
    {
      NotificationChain msgs = null;
      if (violation != null)
        msgs = ((InternalEObject)violation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__VIOLATION, null, msgs);
      if (newViolation != null)
        msgs = ((InternalEObject)newViolation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.SLO__VIOLATION, null, msgs);
      msgs = basicSetViolation(newViolation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.SLO__VIOLATION, newViolation, newViolation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE:
        return basicSetMetricClauseType(null, msgs);
      case DescartesQLPackage.SLO__VALUE:
        return basicSetValue(null, msgs);
      case DescartesQLPackage.SLO__FUZ:
        return basicSetFuz(null, msgs);
      case DescartesQLPackage.SLO__PEN:
        return basicSetPen(null, msgs);
      case DescartesQLPackage.SLO__VIOLATION:
        return basicSetViolation(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.SLO__NAME:
        return getName();
      case DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE:
        return getMetricClauseType();
      case DescartesQLPackage.SLO__COMPARATOR:
        return getComparator();
      case DescartesQLPackage.SLO__VALUE:
        return getValue();
      case DescartesQLPackage.SLO__FUZ:
        return getFuz();
      case DescartesQLPackage.SLO__PEN:
        return getPen();
      case DescartesQLPackage.SLO__VIOLATION:
        return getViolation();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.SLO__NAME:
        setName((String)newValue);
        return;
      case DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE:
        setMetricClauseType((MetricClauseType)newValue);
        return;
      case DescartesQLPackage.SLO__COMPARATOR:
        setComparator((Comparator)newValue);
        return;
      case DescartesQLPackage.SLO__VALUE:
        setValue((VariableValue)newValue);
        return;
      case DescartesQLPackage.SLO__FUZ:
        setFuz((Fuzziness)newValue);
        return;
      case DescartesQLPackage.SLO__PEN:
        setPen((Penalty)newValue);
        return;
      case DescartesQLPackage.SLO__VIOLATION:
        setViolation((Violation)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.SLO__NAME:
        setName(NAME_EDEFAULT);
        return;
      case DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE:
        setMetricClauseType((MetricClauseType)null);
        return;
      case DescartesQLPackage.SLO__COMPARATOR:
        setComparator(COMPARATOR_EDEFAULT);
        return;
      case DescartesQLPackage.SLO__VALUE:
        setValue((VariableValue)null);
        return;
      case DescartesQLPackage.SLO__FUZ:
        setFuz((Fuzziness)null);
        return;
      case DescartesQLPackage.SLO__PEN:
        setPen((Penalty)null);
        return;
      case DescartesQLPackage.SLO__VIOLATION:
        setViolation((Violation)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.SLO__NAME:
        return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
      case DescartesQLPackage.SLO__METRIC_CLAUSE_TYPE:
        return metricClauseType != null;
      case DescartesQLPackage.SLO__COMPARATOR:
        return comparator != COMPARATOR_EDEFAULT;
      case DescartesQLPackage.SLO__VALUE:
        return value != null;
      case DescartesQLPackage.SLO__FUZ:
        return fuz != null;
      case DescartesQLPackage.SLO__PEN:
        return pen != null;
      case DescartesQLPackage.SLO__VIOLATION:
        return violation != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (name: ");
    result.append(name);
    result.append(", comparator: ");
    result.append(comparator);
    result.append(')');
    return result.toString();
  }

} //SloImpl
