/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.FilteringClause;
import tools.descartes.dql.lang.descartesQL.ForClause;
import tools.descartes.dql.lang.descartesQL.MetricReferenceClauses;
import tools.descartes.dql.lang.descartesQL.UsingClause;
import tools.descartes.dql.lang.descartesQL.WhatIfQuery;
import tools.descartes.dql.lang.descartesQL.WhatIfVariation;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>What If Query</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getWhatIfVariation <em>What If Variation</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getMetricReferenceClauses <em>Metric Reference Clauses</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getFilteringClause <em>Filtering Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getDeltaClause <em>Delta Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfQueryImpl#getUsingClause <em>Using Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class WhatIfQueryImpl extends MinimalEObjectImpl.Container implements WhatIfQuery
{
  /**
   * The cached value of the '{@link #getWhatIfVariation() <em>What If Variation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWhatIfVariation()
   * @generated
   * @ordered
   */
  protected WhatIfVariation whatIfVariation;

  /**
   * The cached value of the '{@link #getMetricReferenceClauses() <em>Metric Reference Clauses</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetricReferenceClauses()
   * @generated
   * @ordered
   */
  protected MetricReferenceClauses metricReferenceClauses;

  /**
   * The cached value of the '{@link #getForClause() <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getForClause()
   * @generated
   * @ordered
   */
  protected ForClause forClause;

  /**
   * The cached value of the '{@link #getFilteringClause() <em>Filtering Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilteringClause()
   * @generated
   * @ordered
   */
  protected FilteringClause filteringClause;

  /**
   * The default value of the '{@link #getDeltaClause() <em>Delta Clause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDeltaClause()
   * @generated
   * @ordered
   */
  protected static final String DELTA_CLAUSE_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getDeltaClause() <em>Delta Clause</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getDeltaClause()
   * @generated
   * @ordered
   */
  protected String deltaClause = DELTA_CLAUSE_EDEFAULT;

  /**
   * The cached value of the '{@link #getUsingClause() <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUsingClause()
   * @generated
   * @ordered
   */
  protected UsingClause usingClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WhatIfQueryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.WHAT_IF_QUERY;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WhatIfVariation getWhatIfVariation()
  {
    return whatIfVariation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetWhatIfVariation(WhatIfVariation newWhatIfVariation, NotificationChain msgs)
  {
    WhatIfVariation oldWhatIfVariation = whatIfVariation;
    whatIfVariation = newWhatIfVariation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION, oldWhatIfVariation, newWhatIfVariation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setWhatIfVariation(WhatIfVariation newWhatIfVariation)
  {
    if (newWhatIfVariation != whatIfVariation)
    {
      NotificationChain msgs = null;
      if (whatIfVariation != null)
        msgs = ((InternalEObject)whatIfVariation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION, null, msgs);
      if (newWhatIfVariation != null)
        msgs = ((InternalEObject)newWhatIfVariation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION, null, msgs);
      msgs = basicSetWhatIfVariation(newWhatIfVariation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION, newWhatIfVariation, newWhatIfVariation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricReferenceClauses getMetricReferenceClauses()
  {
    return metricReferenceClauses;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMetricReferenceClauses(MetricReferenceClauses newMetricReferenceClauses, NotificationChain msgs)
  {
    MetricReferenceClauses oldMetricReferenceClauses = metricReferenceClauses;
    metricReferenceClauses = newMetricReferenceClauses;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES, oldMetricReferenceClauses, newMetricReferenceClauses);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMetricReferenceClauses(MetricReferenceClauses newMetricReferenceClauses)
  {
    if (newMetricReferenceClauses != metricReferenceClauses)
    {
      NotificationChain msgs = null;
      if (metricReferenceClauses != null)
        msgs = ((InternalEObject)metricReferenceClauses).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES, null, msgs);
      if (newMetricReferenceClauses != null)
        msgs = ((InternalEObject)newMetricReferenceClauses).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES, null, msgs);
      msgs = basicSetMetricReferenceClauses(newMetricReferenceClauses, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES, newMetricReferenceClauses, newMetricReferenceClauses));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ForClause getForClause()
  {
    return forClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetForClause(ForClause newForClause, NotificationChain msgs)
  {
    ForClause oldForClause = forClause;
    forClause = newForClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE, oldForClause, newForClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setForClause(ForClause newForClause)
  {
    if (newForClause != forClause)
    {
      NotificationChain msgs = null;
      if (forClause != null)
        msgs = ((InternalEObject)forClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE, null, msgs);
      if (newForClause != null)
        msgs = ((InternalEObject)newForClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE, null, msgs);
      msgs = basicSetForClause(newForClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE, newForClause, newForClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringClause getFilteringClause()
  {
    return filteringClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFilteringClause(FilteringClause newFilteringClause, NotificationChain msgs)
  {
    FilteringClause oldFilteringClause = filteringClause;
    filteringClause = newFilteringClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE, oldFilteringClause, newFilteringClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFilteringClause(FilteringClause newFilteringClause)
  {
    if (newFilteringClause != filteringClause)
    {
      NotificationChain msgs = null;
      if (filteringClause != null)
        msgs = ((InternalEObject)filteringClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE, null, msgs);
      if (newFilteringClause != null)
        msgs = ((InternalEObject)newFilteringClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE, null, msgs);
      msgs = basicSetFilteringClause(newFilteringClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE, newFilteringClause, newFilteringClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getDeltaClause()
  {
    return deltaClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setDeltaClause(String newDeltaClause)
  {
    String oldDeltaClause = deltaClause;
    deltaClause = newDeltaClause;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__DELTA_CLAUSE, oldDeltaClause, deltaClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UsingClause getUsingClause()
  {
    return usingClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetUsingClause(UsingClause newUsingClause, NotificationChain msgs)
  {
    UsingClause oldUsingClause = usingClause;
    usingClause = newUsingClause;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE, oldUsingClause, newUsingClause);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUsingClause(UsingClause newUsingClause)
  {
    if (newUsingClause != usingClause)
    {
      NotificationChain msgs = null;
      if (usingClause != null)
        msgs = ((InternalEObject)usingClause).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE, null, msgs);
      if (newUsingClause != null)
        msgs = ((InternalEObject)newUsingClause).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE, null, msgs);
      msgs = basicSetUsingClause(newUsingClause, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE, newUsingClause, newUsingClause));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION:
        return basicSetWhatIfVariation(null, msgs);
      case DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES:
        return basicSetMetricReferenceClauses(null, msgs);
      case DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE:
        return basicSetForClause(null, msgs);
      case DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE:
        return basicSetFilteringClause(null, msgs);
      case DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE:
        return basicSetUsingClause(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION:
        return getWhatIfVariation();
      case DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES:
        return getMetricReferenceClauses();
      case DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE:
        return getForClause();
      case DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE:
        return getFilteringClause();
      case DescartesQLPackage.WHAT_IF_QUERY__DELTA_CLAUSE:
        return getDeltaClause();
      case DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE:
        return getUsingClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION:
        setWhatIfVariation((WhatIfVariation)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES:
        setMetricReferenceClauses((MetricReferenceClauses)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE:
        setForClause((ForClause)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE:
        setFilteringClause((FilteringClause)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__DELTA_CLAUSE:
        setDeltaClause((String)newValue);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE:
        setUsingClause((UsingClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION:
        setWhatIfVariation((WhatIfVariation)null);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES:
        setMetricReferenceClauses((MetricReferenceClauses)null);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE:
        setForClause((ForClause)null);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE:
        setFilteringClause((FilteringClause)null);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__DELTA_CLAUSE:
        setDeltaClause(DELTA_CLAUSE_EDEFAULT);
        return;
      case DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE:
        setUsingClause((UsingClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_QUERY__WHAT_IF_VARIATION:
        return whatIfVariation != null;
      case DescartesQLPackage.WHAT_IF_QUERY__METRIC_REFERENCE_CLAUSES:
        return metricReferenceClauses != null;
      case DescartesQLPackage.WHAT_IF_QUERY__FOR_CLAUSE:
        return forClause != null;
      case DescartesQLPackage.WHAT_IF_QUERY__FILTERING_CLAUSE:
        return filteringClause != null;
      case DescartesQLPackage.WHAT_IF_QUERY__DELTA_CLAUSE:
        return DELTA_CLAUSE_EDEFAULT == null ? deltaClause != null : !DELTA_CLAUSE_EDEFAULT.equals(deltaClause);
      case DescartesQLPackage.WHAT_IF_QUERY__USING_CLAUSE:
        return usingClause != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (deltaClause: ");
    result.append(deltaClause);
    result.append(')');
    return result.toString();
  }

} //WhatIfQueryImpl
