/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Entity</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getIdentifier <em>Identifier</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getAlias <em>Alias</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getProbes <em>Probes</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getEntityType <em>Entity Type</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getParent <em>Parent</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.Entity#getChildren <em>Children</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity()
 * @model
 * @generated
 */
public interface Entity extends EObject {
	/**
	 * Returns the value of the '<em><b>Identifier</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Identifier</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Identifier</em>' attribute.
	 * @see #setIdentifier(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_Identifier()
	 * @model default=""
	 * @generated
	 */
	String getIdentifier();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.Entity#getIdentifier <em>Identifier</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Identifier</em>' attribute.
	 * @see #getIdentifier()
	 * @generated
	 */
	void setIdentifier(String value);

	/**
	 * Returns the value of the '<em><b>Alias</b></em>' attribute.
	 * The default value is <code>""</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Alias</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alias</em>' attribute.
	 * @see #setAlias(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_Alias()
	 * @model default=""
	 * @generated
	 */
	String getAlias();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.Entity#getAlias <em>Alias</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alias</em>' attribute.
	 * @see #getAlias()
	 * @generated
	 */
	void setAlias(String value);

	/**
	 * Returns the value of the '<em><b>Probes</b></em>' containment reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.Probe}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Probes</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Probes</em>' containment reference list.
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_Probes()
	 * @model containment="true"
	 * @generated
	 */
	EList<Probe> getProbes();

	/**
	 * Returns the value of the '<em><b>Entity Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Entity Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Entity Type</em>' attribute.
	 * @see #setEntityType(String)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_EntityType()
	 * @model
	 * @generated
	 */
	String getEntityType();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.Entity#getEntityType <em>Entity Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Entity Type</em>' attribute.
	 * @see #getEntityType()
	 * @generated
	 */
	void setEntityType(String value);

	/**
	 * Returns the value of the '<em><b>Parent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent</em>' reference.
	 * @see #setParent(Entity)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_Parent()
	 * @model
	 * @generated
	 */
	Entity getParent();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.Entity#getParent <em>Parent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent</em>' reference.
	 * @see #getParent()
	 * @generated
	 */
	void setParent(Entity value);

	/**
	 * Returns the value of the '<em><b>Children</b></em>' reference list.
	 * The list contents are of type {@link tools.descartes.dql.models.mapping.domain.Entity}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Children</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Children</em>' reference list.
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getEntity_Children()
	 * @model
	 * @generated
	 */
	EList<Entity> getChildren();

} // Entity
