/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain.impl;

import java.math.BigDecimal;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import tools.descartes.dql.models.mapping.domain.ConfidenceInterval;
import tools.descartes.dql.models.mapping.domain.DomainPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Confidence Interval</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl#getAccuracy <em>Accuracy</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.impl.ConfidenceIntervalImpl#getIntervalHalfLength <em>Interval Half Length</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ConfidenceIntervalImpl extends EObjectImpl implements ConfidenceInterval {
	/**
	 * The default value of the '{@link #getAccuracy() <em>Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAccuracy()
	 * @generated
	 * @ordered
	 */
	protected static final BigDecimal ACCURACY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAccuracy() <em>Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAccuracy()
	 * @generated
	 * @ordered
	 */
	protected BigDecimal accuracy = ACCURACY_EDEFAULT;

	/**
	 * The default value of the '{@link #getIntervalHalfLength() <em>Interval Half Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntervalHalfLength()
	 * @generated
	 * @ordered
	 */
	protected static final BigDecimal INTERVAL_HALF_LENGTH_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIntervalHalfLength() <em>Interval Half Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIntervalHalfLength()
	 * @generated
	 * @ordered
	 */
	protected BigDecimal intervalHalfLength = INTERVAL_HALF_LENGTH_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ConfidenceIntervalImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return DomainPackage.Literals.CONFIDENCE_INTERVAL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BigDecimal getAccuracy() {
		return accuracy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAccuracy(BigDecimal newAccuracy) {
		BigDecimal oldAccuracy = accuracy;
		accuracy = newAccuracy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DomainPackage.CONFIDENCE_INTERVAL__ACCURACY, oldAccuracy, accuracy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BigDecimal getIntervalHalfLength() {
		return intervalHalfLength;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIntervalHalfLength(BigDecimal newIntervalHalfLength) {
		BigDecimal oldIntervalHalfLength = intervalHalfLength;
		intervalHalfLength = newIntervalHalfLength;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, DomainPackage.CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH, oldIntervalHalfLength, intervalHalfLength));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case DomainPackage.CONFIDENCE_INTERVAL__ACCURACY:
				return getAccuracy();
			case DomainPackage.CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH:
				return getIntervalHalfLength();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case DomainPackage.CONFIDENCE_INTERVAL__ACCURACY:
				setAccuracy((BigDecimal)newValue);
				return;
			case DomainPackage.CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH:
				setIntervalHalfLength((BigDecimal)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case DomainPackage.CONFIDENCE_INTERVAL__ACCURACY:
				setAccuracy(ACCURACY_EDEFAULT);
				return;
			case DomainPackage.CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH:
				setIntervalHalfLength(INTERVAL_HALF_LENGTH_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case DomainPackage.CONFIDENCE_INTERVAL__ACCURACY:
				return ACCURACY_EDEFAULT == null ? accuracy != null : !ACCURACY_EDEFAULT.equals(accuracy);
			case DomainPackage.CONFIDENCE_INTERVAL__INTERVAL_HALF_LENGTH:
				return INTERVAL_HALF_LENGTH_EDEFAULT == null ? intervalHalfLength != null : !INTERVAL_HALF_LENGTH_EDEFAULT.equals(intervalHalfLength);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (accuracy: ");
		result.append(accuracy);
		result.append(", IntervalHalfLength: ");
		result.append(intervalHalfLength);
		result.append(')');
		return result.toString();
	}

} //ConfidenceIntervalImpl
