/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.filter.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;

import tools.descartes.dql.models.mapping.filter.BinaryConjunction;
import tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator;
import tools.descartes.dql.models.mapping.filter.Conjunction;
import tools.descartes.dql.models.mapping.filter.FilterPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Binary Conjunction</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl#getLeftConjunction <em>Left Conjunction</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl#getRightConjunction <em>Right Conjunction</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl#getLogicalOperator <em>Logical Operator</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BinaryConjunctionImpl extends ConjunctionImpl implements BinaryConjunction {
	/**
	 * The cached value of the '{@link #getLeftConjunction() <em>Left Conjunction</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLeftConjunction()
	 * @generated
	 * @ordered
	 */
	protected Conjunction leftConjunction;

	/**
	 * The cached value of the '{@link #getRightConjunction() <em>Right Conjunction</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRightConjunction()
	 * @generated
	 * @ordered
	 */
	protected Conjunction rightConjunction;

	/**
	 * The default value of the '{@link #getLogicalOperator() <em>Logical Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogicalOperator()
	 * @generated
	 * @ordered
	 */
	protected static final BinaryConjunctionOperator LOGICAL_OPERATOR_EDEFAULT = BinaryConjunctionOperator.AND;

	/**
	 * The cached value of the '{@link #getLogicalOperator() <em>Logical Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLogicalOperator()
	 * @generated
	 * @ordered
	 */
	protected BinaryConjunctionOperator logicalOperator = LOGICAL_OPERATOR_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BinaryConjunctionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return FilterPackage.Literals.BINARY_CONJUNCTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction getLeftConjunction() {
		if (leftConjunction != null && leftConjunction.eIsProxy()) {
			InternalEObject oldLeftConjunction = (InternalEObject)leftConjunction;
			leftConjunction = (Conjunction)eResolveProxy(oldLeftConjunction);
			if (leftConjunction != oldLeftConjunction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION, oldLeftConjunction, leftConjunction));
			}
		}
		return leftConjunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction basicGetLeftConjunction() {
		return leftConjunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLeftConjunction(Conjunction newLeftConjunction) {
		Conjunction oldLeftConjunction = leftConjunction;
		leftConjunction = newLeftConjunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION, oldLeftConjunction, leftConjunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction getRightConjunction() {
		if (rightConjunction != null && rightConjunction.eIsProxy()) {
			InternalEObject oldRightConjunction = (InternalEObject)rightConjunction;
			rightConjunction = (Conjunction)eResolveProxy(oldRightConjunction);
			if (rightConjunction != oldRightConjunction) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION, oldRightConjunction, rightConjunction));
			}
		}
		return rightConjunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Conjunction basicGetRightConjunction() {
		return rightConjunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRightConjunction(Conjunction newRightConjunction) {
		Conjunction oldRightConjunction = rightConjunction;
		rightConjunction = newRightConjunction;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION, oldRightConjunction, rightConjunction));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BinaryConjunctionOperator getLogicalOperator() {
		return logicalOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLogicalOperator(BinaryConjunctionOperator newLogicalOperator) {
		BinaryConjunctionOperator oldLogicalOperator = logicalOperator;
		logicalOperator = newLogicalOperator == null ? LOGICAL_OPERATOR_EDEFAULT : newLogicalOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, FilterPackage.BINARY_CONJUNCTION__LOGICAL_OPERATOR, oldLogicalOperator, logicalOperator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION:
				if (resolve) return getLeftConjunction();
				return basicGetLeftConjunction();
			case FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION:
				if (resolve) return getRightConjunction();
				return basicGetRightConjunction();
			case FilterPackage.BINARY_CONJUNCTION__LOGICAL_OPERATOR:
				return getLogicalOperator();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION:
				setLeftConjunction((Conjunction)newValue);
				return;
			case FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION:
				setRightConjunction((Conjunction)newValue);
				return;
			case FilterPackage.BINARY_CONJUNCTION__LOGICAL_OPERATOR:
				setLogicalOperator((BinaryConjunctionOperator)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION:
				setLeftConjunction((Conjunction)null);
				return;
			case FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION:
				setRightConjunction((Conjunction)null);
				return;
			case FilterPackage.BINARY_CONJUNCTION__LOGICAL_OPERATOR:
				setLogicalOperator(LOGICAL_OPERATOR_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case FilterPackage.BINARY_CONJUNCTION__LEFT_CONJUNCTION:
				return leftConjunction != null;
			case FilterPackage.BINARY_CONJUNCTION__RIGHT_CONJUNCTION:
				return rightConjunction != null;
			case FilterPackage.BINARY_CONJUNCTION__LOGICAL_OPERATOR:
				return logicalOperator != LOGICAL_OPERATOR_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (logicalOperator: ");
		result.append(logicalOperator);
		result.append(')');
		return result.toString();
	}

} //BinaryConjunctionImpl
