/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.repository;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.models.repository.RepositoryFactory
 * @model kind="package"
 * @generated
 */
public interface RepositoryPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "repository";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dql/models/repository/repository/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "repository";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	RepositoryPackage eINSTANCE = tools.descartes.dql.models.repository.impl.RepositoryPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.repository.impl.IdentfierImpl <em>Identfier</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.repository.impl.IdentfierImpl
	 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getIdentfier()
	 * @generated
	 */
	int IDENTFIER = 4;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTFIER__IDENTIFIER = 0;

	/**
	 * The number of structural features of the '<em>Identfier</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IDENTFIER_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl <em>Observation Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl
	 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservationRepository()
	 * @generated
	 */
	int OBSERVATION_REPOSITORY = 0;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__IDENTIFIER = IDENTFIER__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Impacts</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__IMPACTS = IDENTFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__OBSERVATIONS = IDENTFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Start Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__START_TIMESTAMP = IDENTFIER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>End Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__END_TIMESTAMP = IDENTFIER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Latest Observation</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__LATEST_OBSERVATION = IDENTFIER_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Latest Impact</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY__LATEST_IMPACT = IDENTFIER_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Observation Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_REPOSITORY_FEATURE_COUNT = IDENTFIER_FEATURE_COUNT + 6;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.repository.impl.ObservationImpl <em>Observation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.repository.impl.ObservationImpl
	 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservation()
	 * @generated
	 */
	int OBSERVATION = 1;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION__IDENTIFIER = IDENTFIER__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION__TIMESTAMP = IDENTFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Observation</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION__OBSERVATION = IDENTFIER_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Observation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVATION_FEATURE_COUNT = IDENTFIER_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.repository.impl.ObservableImpactImpl <em>Observable Impact</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.repository.impl.ObservableImpactImpl
	 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservableImpact()
	 * @generated
	 */
	int OBSERVABLE_IMPACT = 2;

	/**
	 * The feature id for the '<em><b>Identifier</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_IMPACT__IDENTIFIER = IDENTFIER__IDENTIFIER;

	/**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_IMPACT__TIMESTAMP = IDENTFIER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Before</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_IMPACT__BEFORE = IDENTFIER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>After</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_IMPACT__AFTER = IDENTFIER_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Observable Impact</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OBSERVABLE_IMPACT_FEATURE_COUNT = IDENTFIER_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.repository.impl.TemporalObservationImpl <em>Temporal Observation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.repository.impl.TemporalObservationImpl
	 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getTemporalObservation()
	 * @generated
	 */
	int TEMPORAL_OBSERVATION = 3;

	/**
	 * The feature id for the '<em><b>Timestamp</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEMPORAL_OBSERVATION__TIMESTAMP = 0;

	/**
	 * The number of structural features of the '<em>Temporal Observation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TEMPORAL_OBSERVATION_FEATURE_COUNT = 1;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.repository.ObservationRepository <em>Observation Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Observation Repository</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository
	 * @generated
	 */
	EClass getObservationRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.repository.ObservationRepository#getImpacts <em>Impacts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Impacts</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getImpacts()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EReference getObservationRepository_Impacts();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dql.models.repository.ObservationRepository#getObservations <em>Observations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Observations</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getObservations()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EReference getObservationRepository_Observations();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.repository.ObservationRepository#getStartTimestamp <em>Start Timestamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start Timestamp</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getStartTimestamp()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EAttribute getObservationRepository_StartTimestamp();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.repository.ObservationRepository#getEndTimestamp <em>End Timestamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>End Timestamp</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getEndTimestamp()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EAttribute getObservationRepository_EndTimestamp();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestObservation <em>Latest Observation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Latest Observation</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getLatestObservation()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EReference getObservationRepository_LatestObservation();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.repository.ObservationRepository#getLatestImpact <em>Latest Impact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Latest Impact</em>'.
	 * @see tools.descartes.dql.models.repository.ObservationRepository#getLatestImpact()
	 * @see #getObservationRepository()
	 * @generated
	 */
	EReference getObservationRepository_LatestImpact();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.repository.Observation <em>Observation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Observation</em>'.
	 * @see tools.descartes.dql.models.repository.Observation
	 * @generated
	 */
	EClass getObservation();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dql.models.repository.Observation#getObservation <em>Observation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Observation</em>'.
	 * @see tools.descartes.dql.models.repository.Observation#getObservation()
	 * @see #getObservation()
	 * @generated
	 */
	EReference getObservation_Observation();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.repository.ObservableImpact <em>Observable Impact</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Observable Impact</em>'.
	 * @see tools.descartes.dql.models.repository.ObservableImpact
	 * @generated
	 */
	EClass getObservableImpact();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.repository.ObservableImpact#getBefore <em>Before</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Before</em>'.
	 * @see tools.descartes.dql.models.repository.ObservableImpact#getBefore()
	 * @see #getObservableImpact()
	 * @generated
	 */
	EReference getObservableImpact_Before();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.repository.ObservableImpact#getAfter <em>After</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>After</em>'.
	 * @see tools.descartes.dql.models.repository.ObservableImpact#getAfter()
	 * @see #getObservableImpact()
	 * @generated
	 */
	EReference getObservableImpact_After();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.repository.TemporalObservation <em>Temporal Observation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Temporal Observation</em>'.
	 * @see tools.descartes.dql.models.repository.TemporalObservation
	 * @generated
	 */
	EClass getTemporalObservation();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.repository.TemporalObservation#getTimestamp <em>Timestamp</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Timestamp</em>'.
	 * @see tools.descartes.dql.models.repository.TemporalObservation#getTimestamp()
	 * @see #getTemporalObservation()
	 * @generated
	 */
	EAttribute getTemporalObservation_Timestamp();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.repository.Identfier <em>Identfier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Identfier</em>'.
	 * @see tools.descartes.dql.models.repository.Identfier
	 * @generated
	 */
	EClass getIdentfier();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.repository.Identfier#getIdentifier <em>Identifier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Identifier</em>'.
	 * @see tools.descartes.dql.models.repository.Identfier#getIdentifier()
	 * @see #getIdentfier()
	 * @generated
	 */
	EAttribute getIdentfier_Identifier();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	RepositoryFactory getRepositoryFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl <em>Observation Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl
		 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservationRepository()
		 * @generated
		 */
		EClass OBSERVATION_REPOSITORY = eINSTANCE.getObservationRepository();

		/**
		 * The meta object literal for the '<em><b>Impacts</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVATION_REPOSITORY__IMPACTS = eINSTANCE.getObservationRepository_Impacts();

		/**
		 * The meta object literal for the '<em><b>Observations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVATION_REPOSITORY__OBSERVATIONS = eINSTANCE.getObservationRepository_Observations();

		/**
		 * The meta object literal for the '<em><b>Start Timestamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OBSERVATION_REPOSITORY__START_TIMESTAMP = eINSTANCE.getObservationRepository_StartTimestamp();

		/**
		 * The meta object literal for the '<em><b>End Timestamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute OBSERVATION_REPOSITORY__END_TIMESTAMP = eINSTANCE.getObservationRepository_EndTimestamp();

		/**
		 * The meta object literal for the '<em><b>Latest Observation</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVATION_REPOSITORY__LATEST_OBSERVATION = eINSTANCE.getObservationRepository_LatestObservation();

		/**
		 * The meta object literal for the '<em><b>Latest Impact</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVATION_REPOSITORY__LATEST_IMPACT = eINSTANCE.getObservationRepository_LatestImpact();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.repository.impl.ObservationImpl <em>Observation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.repository.impl.ObservationImpl
		 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservation()
		 * @generated
		 */
		EClass OBSERVATION = eINSTANCE.getObservation();

		/**
		 * The meta object literal for the '<em><b>Observation</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVATION__OBSERVATION = eINSTANCE.getObservation_Observation();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.repository.impl.ObservableImpactImpl <em>Observable Impact</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.repository.impl.ObservableImpactImpl
		 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getObservableImpact()
		 * @generated
		 */
		EClass OBSERVABLE_IMPACT = eINSTANCE.getObservableImpact();

		/**
		 * The meta object literal for the '<em><b>Before</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVABLE_IMPACT__BEFORE = eINSTANCE.getObservableImpact_Before();

		/**
		 * The meta object literal for the '<em><b>After</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OBSERVABLE_IMPACT__AFTER = eINSTANCE.getObservableImpact_After();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.repository.impl.TemporalObservationImpl <em>Temporal Observation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.repository.impl.TemporalObservationImpl
		 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getTemporalObservation()
		 * @generated
		 */
		EClass TEMPORAL_OBSERVATION = eINSTANCE.getTemporalObservation();

		/**
		 * The meta object literal for the '<em><b>Timestamp</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TEMPORAL_OBSERVATION__TIMESTAMP = eINSTANCE.getTemporalObservation_Timestamp();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.repository.impl.IdentfierImpl <em>Identfier</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.repository.impl.IdentfierImpl
		 * @see tools.descartes.dql.models.repository.impl.RepositoryPackageImpl#getIdentfier()
		 * @generated
		 */
		EClass IDENTFIER = eINSTANCE.getIdentfier();

		/**
		 * The meta object literal for the '<em><b>Identifier</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute IDENTFIER__IDENTIFIER = eINSTANCE.getIdentfier_Identifier();

	}

} //RepositoryPackage
